"use strict";

const { required, string, integer, boolean, date, optional, defaultTo, addCollection, addFields, addIndex } = require("../../../src/schema/methods/v1");

module.exports = [
	addCollection("users", [
		addFields({
			username: [ required, string ],
			passwordHash: [ required, string ],
			emailAddress: [ optional, string ],
			invitesLeft: [ required, integer, defaultTo(0) ],
			isActive: [ required, boolean, defaultTo(false) ],
			registrationDate: [ required, date, defaultTo(() => new Date()) ]
		}),
		addIndex("username"),
		addIndex("registrationDate"),
	])
];
