"use strict";

module.exports = function compose(funcs) {
	return function (value) {
		if (funcs.length > 0) {
			return funcs.reduce((last, func) => func(last), value);
		} else {
			// Identity function
			return (value) => value;
		}
	};
};
